From 32908e516a2ea66f226bef543a81b0a22d9a1169 Mon Sep 17 00:00:00 2001
From: Amul Sul <amul.sul@enterprisedb.com>
Date: Tue, 13 Dec 2022 14:28:19 +0530
Subject: [PATCH v1 09/25] Change gtsvectorin to allow non-throw error
 reporting

---
 src/backend/utils/adt/tsgistidx.c         |  2 +-
 src/test/regress/expected/type_sanity.out | 12 ++++++++++++
 src/test/regress/sql/type_sanity.sql      |  3 +++
 3 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/src/backend/utils/adt/tsgistidx.c b/src/backend/utils/adt/tsgistidx.c
index cabfe4d1485..13e6fcf067b 100644
--- a/src/backend/utils/adt/tsgistidx.c
+++ b/src/backend/utils/adt/tsgistidx.c
@@ -88,7 +88,7 @@ Datum
 gtsvectorin(PG_FUNCTION_ARGS)
 {
 	/* There's no need to support input of gtsvectors */
-	ereport(ERROR,
+	ereturn(fcinfo->context, (Datum) 0,
 			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 			 errmsg("cannot accept a value of type %s", "gtsvector")));
 
diff --git a/src/test/regress/expected/type_sanity.out b/src/test/regress/expected/type_sanity.out
index 140dc6b948a..0b015b424f1 100644
--- a/src/test/regress/expected/type_sanity.out
+++ b/src/test/regress/expected/type_sanity.out
@@ -820,3 +820,15 @@ SELECT pg_input_error_message('1', 'pg_brin_minmax_multi_summary');
  cannot accept a value of type brin_minmax_multi_summary
 (1 row)
 
+SELECT pg_input_is_valid('1', 'gtsvector');
+ pg_input_is_valid 
+-------------------
+ f
+(1 row)
+
+SELECT pg_input_error_message('1', 'gtsvector');
+         pg_input_error_message          
+-----------------------------------------
+ cannot accept a value of type gtsvector
+(1 row)
+
diff --git a/src/test/regress/sql/type_sanity.sql b/src/test/regress/sql/type_sanity.sql
index 7c1aff8a65b..d024d950b3e 100644
--- a/src/test/regress/sql/type_sanity.sql
+++ b/src/test/regress/sql/type_sanity.sql
@@ -602,3 +602,6 @@ SELECT pg_input_error_message('1', 'pg_brin_bloom_summary');
 
 SELECT pg_input_is_valid('1', 'pg_brin_minmax_multi_summary');
 SELECT pg_input_error_message('1', 'pg_brin_minmax_multi_summary');
+
+SELECT pg_input_is_valid('1', 'gtsvector');
+SELECT pg_input_error_message('1', 'gtsvector');
-- 
2.18.0

